CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

        ' Pin definitions
        #0,   uSDMasDO, uSDMasCLK, uSDMasDI, uSDMasCS,{
  }     uSDTar1DO, uSDTar1CLK, uSDTar1DI, uSDTar1CS,{
  }     uSDTar2DO, uSDTar2CLK, uSDTar2DI, uSDTar2CS,{
  }     uSDTar3DO, uSDTar3CLK, uSDTar3DI, uSDTar3CS

VAR
  long  buf[512/4] ' a long-aligned block of 512-bytes (SD size)
   
OBJ
  sd[1+3]       : "safe_spi_2_7"                        ' using VAR to get 4 copies in 4 cogs
  DBG   : "FullDuplexSerialExt.spin"
  

PUB Demo
  DIRA[24..25]~~
  OUTA[24..25]~

  DBG.Start(31, 30, 0, 115_200)
  waitcnt(cnt + clkfreq)
  DBG.Tx(0)
  DBG.Str(String("--- Test Dupping ---",13,13))
  
  'do_copy( (64 << 20) / 512 ) ' copy 64MB
  do_copy( 2 )  'sector(s)


  DBG.Str(String("--- Dupping Completed ---",13,13))

  repeat
    !OUTA[24..25]
    waitcnt(cnt + clkfreq/5)

PUB do_copy( N_blocks_of_512 ) : i

  DBG.Str(String("Inside do_copy",13))
   

  ' read from object 0
  'sd.start( uSDMasDO )
  DBG.Str(String("Reader Start: "))
  DBG.Dec(sd.start( uSDMasDO ))
  DBG.Tx(13) 
  
  ' write to objects 1-3
  'sd[1].start( uSDTar1DO )
  DBG.Str(String("Writer Started: "))
  DBG.Dec(sd[1].start( uSDTar1DO ))
  DBG.Tx(13)
  
  
  'sd[2].start( uSDTar2DO )
  'sd[3].start( uSDTar3DO )

  ' do the copy
  repeat i from 0 to N_blocks_of_512-1
    'sd.readblock( i, @buf )
    DBG.Str(String("Block Read: "))
    DBG.Dec(sd.readblock( i, @buf ))
    DBG.Tx(13)
    
    sd[1].writeblock( i, @buf )
    DBG.Str(String("Block Wrote...",13))
    
    'sd[2].writeblock( i, @buf )
    'sd[3].writeblock( i, @buf )
  
  ' done
  repeat i from 0 to 1 '3
    sd[i].stop

 